/*
 * File: SFM.c
 *
 * Code generated for Simulink model 'SFM'.
 *
 * Model version                  : 1.90
 * Simulink Coder version         : 9.4 (R2020b) 29-Jul-2020
 * C/C++ source code generated on : Fri Sep 10 18:11:28 2021
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "SFM.h"
#include "SFM_private.h"
#include "div_uus32_sat.h"
#include "mul_s32_hiSR.h"

MdlrefDW_SFM_T SFM_MdlrefDW;

/* Block signals (default storage) */
B_SFM_c_T SFM_B;

/* Block states (default storage) */
DW_SFM_f_T SFM_DW;

/*
 * System initialize for atomic system:
 *    '<S27>/Subsytem'
 *    '<S27>/Subsytem2'
 *    '<S27>/Subsytem4'
 *    '<S27>/Subsytem5'
 */
void SFM_Subsytem_Init(DW_Subsytem_SFM_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S31>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S27>/Subsytem'
 *    '<S27>/Subsytem2'
 *    '<S27>/Subsytem4'
 *    '<S27>/Subsytem5'
 */
boolean_T SFM_Subsytem(uint8_T rtu_Enable, boolean_T rtu_Precondition, int16_T
  rtu_inputs, int16_T rtu_threshold, uint8_T rtu_CtrN, DW_Subsytem_SFM_T
  *localDW)
{
  uint8_T rtb_Saturation_h;

  /* Saturate: '<S31>/Saturation' incorporates:
   *  Constant: '<S31>/Constant1'
   *  Sum: '<S31>/Add'
   *  UnitDelay: '<S31>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_h = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_h = 200U;
  }

  /* End of Saturate: '<S31>/Saturation' */

  /* Product: '<S31>/Product' incorporates:
   *  Logic: '<S31>/Logical Operator1'
   *  RelationalOperator: '<S31>/Relational Operator'
   *  UnitDelay: '<S31>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_inputs >= rtu_threshold) ? (int32_T)rtb_Saturation_h : 0);

  /* RelationalOperator: '<S31>/Relational Operator1' */
  return rtb_Saturation_h > rtu_CtrN;
}

/*
 * System initialize for atomic system:
 *    '<S27>/Subsytem1'
 *    '<S27>/Subsytem3'
 */
void SFM_Subsytem1_Init(DW_Subsytem1_SFM_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S32>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S27>/Subsytem1'
 *    '<S27>/Subsytem3'
 */
boolean_T SFM_Subsytem1(uint8_T rtu_Enable, boolean_T rtu_Precondition, int16_T
  rtu_InputS, int16_T rtu_threshold, uint8_T rtu_CtrN, DW_Subsytem1_SFM_T
  *localDW)
{
  uint8_T rtb_Saturation_f;

  /* Saturate: '<S32>/Saturation' incorporates:
   *  Constant: '<S32>/Constant2'
   *  Sum: '<S32>/Add'
   *  UnitDelay: '<S32>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_f = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_f = 200U;
  }

  /* End of Saturate: '<S32>/Saturation' */

  /* Product: '<S32>/Product' incorporates:
   *  Logic: '<S32>/Logical Operator'
   *  RelationalOperator: '<S32>/Relational Operator'
   *  UnitDelay: '<S32>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_InputS <= rtu_threshold) ? (int32_T)rtb_Saturation_f : 0);

  /* RelationalOperator: '<S32>/Relational Operator1' */
  return rtb_Saturation_f > rtu_CtrN;
}

/*
 * Output and update for atomic system:
 *    '<S28>/Subsystem5'
 *    '<S28>/Subsystem6'
 *    '<S28>/Subsystem7'
 *    '<S28>/Subsystem8'
 */
boolean_T SFM_Subsystem5(boolean_T rtu_In1, boolean_T rtu_In2)
{
  /* Logic: '<S37>/Logical Operator' incorporates:
   *  RelationalOperator: '<S37>/Relational Operator'
   *  RelationalOperator: '<S37>/Relational Operator1'
   */
  return (!rtu_In1) && (!rtu_In2);
}

/*
 * System initialize for atomic system:
 *    '<S28>/Subsytem'
 *    '<S28>/Subsytem2'
 *    '<S28>/Subsytem4'
 *    '<S28>/Subsytem5'
 */
void SFM_Subsytem_b_Init(DW_Subsytem_SFM_d_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S41>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S28>/Subsytem'
 *    '<S28>/Subsytem2'
 *    '<S28>/Subsytem4'
 *    '<S28>/Subsytem5'
 */
boolean_T SFM_Subsytem_j(uint8_T rtu_Enable, boolean_T rtu_Precondition,
  uint16_T rtu_inputs, uint16_T rtu_threshold, uint8_T rtu_CtrN,
  DW_Subsytem_SFM_d_T *localDW)
{
  uint8_T rtb_Saturation_h;

  /* Saturate: '<S41>/Saturation' incorporates:
   *  Constant: '<S41>/Constant1'
   *  Sum: '<S41>/Add'
   *  UnitDelay: '<S41>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_h = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_h = 200U;
  }

  /* End of Saturate: '<S41>/Saturation' */

  /* Product: '<S41>/Product' incorporates:
   *  Logic: '<S41>/Logical Operator1'
   *  RelationalOperator: '<S41>/Relational Operator'
   *  UnitDelay: '<S41>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_inputs >= rtu_threshold) ? (int32_T)rtb_Saturation_h : 0);

  /* RelationalOperator: '<S41>/Relational Operator1' */
  return rtb_Saturation_h > rtu_CtrN;
}

/*
 * System initialize for atomic system:
 *    '<S28>/Subsytem1'
 *    '<S28>/Subsytem3'
 */
void SFM_Subsytem1_f_Init(DW_Subsytem1_SFM_k_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S42>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S28>/Subsytem1'
 *    '<S28>/Subsytem3'
 */
boolean_T SFM_Subsytem1_n(uint8_T rtu_Enable, boolean_T rtu_Precondition,
  uint16_T rtu_InputS, uint16_T rtu_threshold, uint8_T rtu_CtrN,
  DW_Subsytem1_SFM_k_T *localDW)
{
  uint8_T rtb_Saturation_i;

  /* Saturate: '<S42>/Saturation' incorporates:
   *  Constant: '<S42>/Constant2'
   *  Sum: '<S42>/Add'
   *  UnitDelay: '<S42>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_i = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_i = 200U;
  }

  /* End of Saturate: '<S42>/Saturation' */

  /* Product: '<S42>/Product' incorporates:
   *  Logic: '<S42>/Logical Operator'
   *  RelationalOperator: '<S42>/Relational Operator'
   *  UnitDelay: '<S42>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_InputS <= rtu_threshold) ? (int32_T)rtb_Saturation_i : 0);

  /* RelationalOperator: '<S42>/Relational Operator1' */
  return rtb_Saturation_i > rtu_CtrN;
}

/*
 * System initialize for atomic system:
 *    '<S28>/Subsytem6'
 *    '<S28>/Subsytem8'
 */
void SFM_Subsytem6_Init(DW_Subsytem6_SFM_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S47>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S28>/Subsytem6'
 *    '<S28>/Subsytem8'
 */
boolean_T SFM_Subsytem6(uint8_T rtu_Enable, boolean_T rtu_Precondition, uint32_T
  rtu_inputs, uint16_T rtu_threshold, uint8_T rtu_CtrN, DW_Subsytem6_SFM_T
  *localDW)
{
  uint8_T rtb_Saturation_h;

  /* Saturate: '<S47>/Saturation' incorporates:
   *  Constant: '<S47>/Constant1'
   *  Sum: '<S47>/Add'
   *  UnitDelay: '<S47>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_h = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_h = 200U;
  }

  /* End of Saturate: '<S47>/Saturation' */

  /* Product: '<S47>/Product' incorporates:
   *  Logic: '<S47>/Logical Operator1'
   *  RelationalOperator: '<S47>/Relational Operator'
   *  UnitDelay: '<S47>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_inputs >= rtu_threshold * 100U) ? (int32_T)rtb_Saturation_h : 0);

  /* RelationalOperator: '<S47>/Relational Operator1' */
  return rtb_Saturation_h > rtu_CtrN;
}

/*
 * System initialize for atomic system:
 *    '<S28>/Subsytem7'
 *    '<S28>/Subsytem9'
 */
void SFM_Subsytem7_Init(DW_Subsytem7_SFM_T *localDW)
{
  /* InitializeConditions for UnitDelay: '<S48>/delay' */
  localDW->delay_DSTATE = 1U;
}

/*
 * Output and update for atomic system:
 *    '<S28>/Subsytem7'
 *    '<S28>/Subsytem9'
 */
boolean_T SFM_Subsytem7(uint8_T rtu_Enable, boolean_T rtu_Precondition, uint32_T
  rtu_InputS, uint16_T rtu_threshold, uint8_T rtu_CtrN, DW_Subsytem7_SFM_T
  *localDW)
{
  uint8_T rtb_Saturation_m;

  /* Saturate: '<S48>/Saturation' incorporates:
   *  Constant: '<S48>/Constant2'
   *  Sum: '<S48>/Add'
   *  UnitDelay: '<S48>/delay'
   */
  if ((uint8_T)(localDW->delay_DSTATE + 1U) < 200) {
    rtb_Saturation_m = (uint8_T)(localDW->delay_DSTATE + 1U);
  } else {
    rtb_Saturation_m = 200U;
  }

  /* End of Saturate: '<S48>/Saturation' */

  /* Product: '<S48>/Product' incorporates:
   *  Logic: '<S48>/Logical Operator'
   *  RelationalOperator: '<S48>/Relational Operator'
   *  UnitDelay: '<S48>/delay'
   */
  localDW->delay_DSTATE = (uint8_T)((rtu_Enable != 0) && rtu_Precondition &&
    (rtu_InputS <= rtu_threshold * 100U) ? (int32_T)rtb_Saturation_m : 0);

  /* RelationalOperator: '<S48>/Relational Operator1' */
  return rtb_Saturation_m > rtu_CtrN;
}

/* System initialize for referenced model: 'SFM' */
void SFM_Init(void)
{
  /* InitializeConditions for UnitDelay: '<S23>/Time_Delay' */
  SFM_DW.Time_Delay_DSTATE = 1U;

  /* SystemInitialize for Chart: '<S13>/Chart' */
  SFM_DW.FirstFlg = true;

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem' */
  SFM_Subsytem_b_Init(&SFM_DW.Subsytem_j0);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem2' */
  SFM_Subsytem_b_Init(&SFM_DW.Subsytem2_p);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem2' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem1' */
  SFM_Subsytem1_f_Init(&SFM_DW.Subsytem1_n);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem1' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem3' */
  SFM_Subsytem1_f_Init(&SFM_DW.Subsytem3_b);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem3' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem4' */
  SFM_Subsytem_b_Init(&SFM_DW.Subsytem4_p);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem4' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem5' */
  SFM_Subsytem_b_Init(&SFM_DW.Subsytem5_l);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem5' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem6' */
  SFM_Subsytem6_Init(&SFM_DW.Subsytem6);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem6' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem8' */
  SFM_Subsytem6_Init(&SFM_DW.Subsytem8);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem8' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem7' */
  SFM_Subsytem7_Init(&SFM_DW.Subsytem7);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem7' */

  /* SystemInitialize for Atomic SubSystem: '<S28>/Subsytem9' */
  SFM_Subsytem7_Init(&SFM_DW.Subsytem9);

  /* End of SystemInitialize for SubSystem: '<S28>/Subsytem9' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem' */
  SFM_Subsytem_Init(&SFM_DW.Subsytem_j);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem2' */
  SFM_Subsytem_Init(&SFM_DW.Subsytem2);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem2' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem1' */
  SFM_Subsytem1_Init(&SFM_DW.Subsytem1_e);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem1' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem3' */
  SFM_Subsytem1_Init(&SFM_DW.Subsytem3);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem3' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem4' */
  SFM_Subsytem_Init(&SFM_DW.Subsytem4);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem4' */

  /* SystemInitialize for Atomic SubSystem: '<S27>/Subsytem5' */
  SFM_Subsytem_Init(&SFM_DW.Subsytem5);

  /* End of SystemInitialize for SubSystem: '<S27>/Subsytem5' */

  /* SystemInitialize for Atomic SubSystem: '<S24>/Subsytem' */
  /* InitializeConditions for UnitDelay: '<S29>/delay' */
  SFM_DW.delay_DSTATE_j = 1U;

  /* End of SystemInitialize for SubSystem: '<S24>/Subsytem' */

  /* SystemInitialize for Atomic SubSystem: '<S24>/Subsytem1' */
  /* InitializeConditions for UnitDelay: '<S30>/delay' */
  SFM_DW.delay_DSTATE = 1U;
   uint8_T i;
   for(i=0;i<17;i++)
	 {
  
  SFM_DW.ChgNr[i]=0;
  SFM_DW.RecNr[i]=0;
  SFM_DW.UdelNr[i]=0;
   }
   SFM_DW.Cntl=0;

  /* End of SystemInitialize for SubSystem: '<S24>/Subsytem1' */
}

/* Output and update for referenced model: 'SFM' */
void SFM(void)
{
  /* local block i/o variables */
  uint32_T rtb_SumU;
  real_T tmp_2;
  int32_T i_0;
  int32_T tmp_0;
  int32_T tmp_1;
  uint32_T qY;
  uint32_T qY_0;
  uint16_T FltCodeArrS[20];
  uint16_T avrgU;
  uint16_T k;
  uint16_T rtb_Saturation;
  uint16_T temp;
  uint16_T tmp_3;
  uint8_T rtb_TmpSignalConversionAtSFun_l[155];
  uint8_T rtb_TmpSignalConversionAtSFunct[155];
  uint8_T rtb_FltActArr[20];
  uint8_T rtb_FltLevelArr[20];
  uint8_T i;
  uint8_T j;
  boolean_T rtb_TmpSignalConversionAtSFun_a[155];
  boolean_T rtb_RelationalOperator1;
  boolean_T rtb_RelationalOperator1_a;
  boolean_T rtb_RelationalOperator1_bb;
  boolean_T rtb_RelationalOperator1_d;
  boolean_T rtb_RelationalOperator1_di;
  boolean_T rtb_RelationalOperator1_eg;
  boolean_T rtb_RelationalOperator1_ep;
  boolean_T rtb_RelationalOperator1_fg;
  boolean_T rtb_RelationalOperator1_gr;
  boolean_T rtb_RelationalOperator1_i;
  boolean_T rtb_RelationalOperator1_it;
  boolean_T rtb_RelationalOperator1_j;
  boolean_T rtb_RelationalOperator1_l;
  boolean_T rtb_RelationalOperator1_lf;
  boolean_T rtb_RelationalOperator1_o;
  boolean_T rtb_RelationalOperator1_p;
  boolean_T rtb_RelationalOperator_et;
  boolean_T tmp;

  /* Saturate: '<S23>/Saturation' incorporates:
   *  Constant: '<S23>/Constant'
   *  Sum: '<S23>/Add'
   *  UnitDelay: '<S23>/Time_Delay'
   */
  if ((uint16_T)(SFM_DW.Time_Delay_DSTATE + 1U) < 60000) {
    rtb_Saturation = (uint16_T)(SFM_DW.Time_Delay_DSTATE + 1U);
  } else {
    rtb_Saturation = 60000U;
  }

  /* End of Saturate: '<S23>/Saturation' */

  /* RelationalOperator: '<S23>/Relational Operator1' incorporates:
   *  Constant: '<S23>/para'
   */
  rtb_RelationalOperator1 = (rtb_Saturation > 2);

  /* Chart: '<S13>/Chart' incorporates:
   *  Constant: '<S13>/Constant'
   *  Constant: '<S13>/Constant1'
   *  Inport: '<Root>/ihv_V_cellU'
   */
  if (!rtb_RelationalOperator1) {
    j = 0U;
    while ((j < 3) && SFM_DW.FirstFlg) {
      for (i = 0U; i < cmnc_num_cellUNum; i++) {
        SFM_DW.CellUArry[j + 3 * i] = ihv_V_cellU[i];
      }

      j++;
    }

    SFM_DW.FirstFlg = false;
    for (j = 0U; j < 2; j++) {
      for (i = 0U; i < cmnc_num_cellUNum; i++) {
        i_0 = 3 * i + j;
        SFM_DW.CellUArry[i_0] = SFM_DW.CellUArry[i_0 + 1];
      }
    }

    for (i = 0U; i < cmnc_num_cellUNum; i++) {
      SFM_DW.CellUArry[3 * i + 2] = ihv_V_cellU[i];
    }

    for (i = 0U; i < cmnc_num_cellUNum - 1; i++) {
      i_0 = 3 * i;
      tmp_1 = (i + 1) * 3;
      i_0 = SFM_DW.CellUArry[i_0 + 2] - SFM_DW.CellUArry[i_0];
      tmp_1 = SFM_DW.CellUArry[tmp_1 + 2] - SFM_DW.CellUArry[tmp_1];
      if (((real_T)i_0 * 0.001 < -0.05) && ((real_T)tmp_1 * 0.001 > 0.05)) {
        tmp_0 = SFM_DW.ChgNr[i] + 1;
        if (tmp_0 > 255) {
          tmp_0 = 255;
        }

        SFM_DW.ChgNr[i] = (uint8_T)tmp_0;
      } else {
        SFM_DW.ChgNr[i] = 0U;
      }

      if ((SFM_DW.ChgNr[i] >= 2) && ((mul_s32_hiSR(i_0, 274877907, 6U) < -1) &&
           (tmp_1 > 1000))) {
        SFM_B.ErrFlg[i] = true;
        SFM_DW.ErrUFlg[i] = true;
        SFM_DW.ErrUFlg[i + 1] = true;
      }

      if (SFM_B.ErrFlg[i] && (i > 0)) {
        for (j = 0U; j < i; j++) {
          i_0 = i - j;
          tmp_1 = i_0 * 3;
          if ((real_T)(SFM_DW.CellUArry[tmp_1 + 2] - SFM_DW.CellUArry[tmp_1 + 1])
              * 0.001 < -0.2) {
            SFM_B.ErrFlg[i_0] = true;
            SFM_DW.ErrUFlg[i_0] = true;
          }
        }
      }
    }

    if ((mul_s32_hiSR(SFM_DW.CellUArry[2] - SFM_DW.CellUArry[1], 274877907, 6U) <
         -1) && (mul_s32_hiSR(SFM_DW.CellUArry[5] - SFM_DW.CellUArry[4],
          274877907, 6U) < -1) && (mul_s32_hiSR(SFM_DW.CellUArry[8] -
          SFM_DW.CellUArry[7], 274877907, 6U) < -1)) {
      SFM_B.GNDFlg = false;
      SFM_DW.ErrUFlg[0] = true;
      SFM_DW.ErrUFlg[1] = true;
      SFM_DW.ErrUFlg[2] = true;
    }

    i = 0U;
    SFM_B.MinU = 10000U;
    SFM_B.MaxU = 0U;
    rtb_SumU = 0U;
    j = 0U;
    while (i < cmnc_num_cellUNum) {
      if (!SFM_DW.ErrUFlg[i]) {
        qY_0 = rtb_SumU + /*MW:OvSatOk*/ ihv_V_cellU[i];
        if (qY_0 < rtb_SumU) {
          qY_0 = MAX_uint32_T;
        }

        rtb_SumU = qY_0;
        i_0 = j + 1;
        if (j + 1 > 255) {
          i_0 = 255;
        }

        j = (uint8_T)i_0;
        if (ihv_V_cellU[i] > SFM_B.MaxU) {
          SFM_B.MaxU = ihv_V_cellU[i];
        }

        if (ihv_V_cellU[i] < SFM_B.MinU) {
          SFM_B.MinU = ihv_V_cellU[i];
        }
      }

      i++;
    }

    if (SFM_B.MaxU - SFM_B.MinU > 3000) {
      qY_0 = rtb_SumU - /*MW:OvSatOk*/ SFM_B.MaxU;
      if (qY_0 > rtb_SumU) {
        qY_0 = 0U;
      }

      qY = qY_0 - /*MW:OvSatOk*/ SFM_B.MinU;
      if (qY > qY_0) {
        qY = 0U;
      }

      qY_0 = div_uus32_sat(qY, j - 2);
      if (qY_0 > 65535U) {
        qY_0 = 65535U;
      }

      avrgU = (uint16_T)qY_0;
      for (i = 0U; i < cmnc_num_cellUNum; i++) {
        if (!SFM_DW.ErrUFlg[i]) {
          tmp_2 = (real_T)(ihv_V_cellU[i] - (uint16_T)qY_0) * 0.001;
          if ((tmp_2 > 1.5) || (tmp_2 < -1.5)) {
            i_0 = SFM_DW.UdelNr[i] + 1;
            if (i_0 > 255) {
              i_0 = 255;
            }

            SFM_DW.UdelNr[i] = (uint8_T)i_0;
          } else {
            SFM_DW.UdelNr[i] = 0U;
          }

          if (SFM_DW.UdelNr[i] >= 2) {
            SFM_B.ErrFlg[i] = true;
            SFM_DW.ErrUFlg[i] = true;
          }
        }
      }
    } else {
      qY_0 = j == 0U ? MAX_uint32_T : rtb_SumU / j;
      if (qY_0 > 65535U) {
        qY_0 = 65535U;
      }

      avrgU = (uint16_T)qY_0;
    }

    for (i = 0U; i < cmnc_num_cellUNum; i++) {
      if (SFM_DW.ErrUFlg[i]) {
        tmp_2 = (real_T)(ihv_V_cellU[i] - avrgU) * 0.001;
        if ((tmp_2 < 0.2) && (tmp_2 > -0.2)) {
          i_0 = SFM_DW.RecNr[i] + 1;
          if (i_0 > 255) {
            i_0 = 255;
          }

          SFM_DW.RecNr[i] = (uint8_T)i_0;
        } else {
          SFM_DW.RecNr[i] = 0U;
        }

        if (SFM_DW.RecNr[i] >= 2) {
          SFM_B.ErrFlg[i] = false;
          SFM_DW.ErrUFlg[i] = false;
          SFM_B.GNDFlg = ((i != 0) && SFM_B.GNDFlg);
        }
      }
    }

    for (i = 0U; i < cmnc_num_cellUNum; i++) {
      if (SFM_DW.ErrUFlg[i]) {
        SFM_B.CellU[i] = avrgU;
      } else {
        SFM_B.CellU[i] = ihv_V_cellU[i];
      }
    }
  } else {
    for (i_0 = 0; i_0 < 28; i_0++) {
      SFM_B.CellU[i_0] = ihv_V_cellU[i_0];
      SFM_B.ErrFlg[i_0] = false;
    }
  }

  i = 0U;
  rtb_SumU = 0U;
  while (i < cmnc_num_cellUNum) {
    qY_0 = rtb_SumU + /*MW:OvSatOk*/ SFM_B.CellU[i];
    if (qY_0 < rtb_SumU) {
      qY_0 = MAX_uint32_T;
    }

    rtb_SumU = qY_0;
    i++;
  }

  for (i_0 = 0; i_0 < 28; i_0++) {
    /* SignalConversion generated from: '<S13>/Chart' */
    sfmv_V_cellU[i_0] = SFM_B.CellU[i_0];
  }




  
  /* Logic: '<S13>/Logical Operator1' */
  tmp = SFM_B.ErrFlg[0];
  for (i_0 = 0; i_0 < 27; i_0++) {
    tmp = (tmp || SFM_B.ErrFlg[i_0 + 1]);
  }

  rtb_RelationalOperator_et = tmp;

  /* Logic: '<S15>/Logical Operator' */
  sfmv_flg_TFlt = false;

  /* SignalConversion: '<S14>/Signal Conversion' incorporates:
   *  Inport: '<Root>/ihd_flg_currFlt'
   */
  sfmd_flg_currFlt = ihd_flg_currFlt;

  /* SignalConversion generated from: '<S13>/Chart' */
  sfmd_V_cellUMax = SFM_B.MaxU;

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem' */
  /* Constant: '<S28>/Constant28' incorporates:
   *  Constant: '<S28>/Constant25'
   *  Constant: '<S28>/Constant27'
   *  Logic: '<S28>/Logical Operator5'
   */
  rtb_RelationalOperator1_ep = SFM_Subsytem_j(1, !rtb_RelationalOperator1,
    sfmd_V_cellUMax, sfmc_V_cellUMaxThr2, 2, &SFM_DW.Subsytem_j0);

  /* End of Outputs for SubSystem: '<S28>/Subsytem' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem2' */
  /* Constant: '<S28>/Constant26' incorporates:
   *  Constant: '<S28>/Constant23'
   *  Constant: '<S28>/Constant24'
   *  Logic: '<S28>/Logical Operator3'
   */
  rtb_RelationalOperator1_j = SFM_Subsytem_j(1, !rtb_RelationalOperator1,
    sfmd_V_cellUMax, sfmc_V_cellUMaxThr1, 2, &SFM_DW.Subsytem2_p);

  /* End of Outputs for SubSystem: '<S28>/Subsytem2' */

  /* SignalConversion generated from: '<S13>/Chart' */
  sfmd_V_cellUMin = SFM_B.MinU;

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem1' */
  /* Constant: '<S28>/Constant22' incorporates:
   *  Constant: '<S28>/Constant20'
   *  Constant: '<S28>/Constant21'
   *  Logic: '<S28>/Logical Operator1'
   */
  rtb_RelationalOperator1_di = SFM_Subsytem1_n(1, !rtb_RelationalOperator1,
    sfmd_V_cellUMin, sfmc_V_cellUMinThr2, 2, &SFM_DW.Subsytem1_n);

  /* End of Outputs for SubSystem: '<S28>/Subsytem1' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem3' */
  /* Constant: '<S28>/Constant19' incorporates:
   *  Constant: '<S28>/Constant10'
   *  Constant: '<S28>/Constant18'
   *  Logic: '<S28>/Logical Operator6'
   */
  rtb_RelationalOperator1_l = SFM_Subsytem1_n(1, !rtb_RelationalOperator1,
    sfmd_V_cellUMin, sfmc_V_cellUMinThr1, 2, &SFM_DW.Subsytem3_b);

  /* End of Outputs for SubSystem: '<S28>/Subsytem3' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem4' */
  /* Constant: '<S28>/Constant14' incorporates:
   *  Constant: '<S28>/Constant12'
   *  Constant: '<S28>/Constant13'
   *  Logic: '<S28>/Logical Operator2'
   *  SignalConversion generated from: '<S13>/Chart'
   *  Sum: '<S28>/Add'
   * */
  rtb_RelationalOperator1_lf = SFM_Subsytem_j(1, !rtb_RelationalOperator1,
    (uint16_T)(sfmd_V_cellUMax - sfmd_V_cellUMin), sfmc_flg_cellUDiffThr2, 2,
    &SFM_DW.Subsytem4_p);

  /* End of Outputs for SubSystem: '<S28>/Subsytem4' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem5' */
  /* Constant: '<S28>/Constant1' incorporates:
   *  Constant: '<S28>/Constant2'
   *  Constant: '<S28>/Constant3'
   *  Logic: '<S28>/Logical Operator9'
   *  SignalConversion generated from: '<S13>/Chart'
   *  Sum: '<S28>/Add1'
   * */
  rtb_RelationalOperator1_eg = SFM_Subsytem_j(1, !rtb_RelationalOperator1,
    (uint16_T)(sfmd_V_cellUMax - sfmd_V_cellUMin), sfmc_flg_cellUDiffThr1, 2,
    &SFM_DW.Subsytem5_l);

  /* End of Outputs for SubSystem: '<S28>/Subsytem5' */

  /* Logic: '<S13>/Logical Operator2' incorporates:
   *  Logic: '<S13>/Logical Operator1'
   */
  sfmd_flg_volFlt = (tmp || rtb_RelationalOperator1);

  /* Outputs for Atomic SubSystem: '<S28>/Subsystem5' */
  rtb_RelationalOperator1_fg = SFM_Subsystem5(sfmd_flg_volFlt,
    rtb_RelationalOperator1);

  /* End of Outputs for SubSystem: '<S28>/Subsystem5' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem6' */
  /* Constant: '<S28>/Constant30' incorporates:
   *  Constant: '<S28>/Constant16'
   *  Constant: '<S28>/Constant29'
   */
  rtb_RelationalOperator1_fg = SFM_Subsytem6(1, rtb_RelationalOperator1_fg,
    rtb_SumU, sfmc_V_battUMaxThr2, 2, &SFM_DW.Subsytem6);

  /* End of Outputs for SubSystem: '<S28>/Subsytem6' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsystem6' */
  rtb_RelationalOperator1_o = SFM_Subsystem5(sfmd_flg_volFlt,
    rtb_RelationalOperator1);

  /* End of Outputs for SubSystem: '<S28>/Subsystem6' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem8' */
  /* Constant: '<S28>/Constant17' incorporates:
   *  Constant: '<S28>/Constant11'
   *  Constant: '<S28>/Constant15'
   */
  rtb_RelationalOperator1_it = SFM_Subsytem6(1, rtb_RelationalOperator1_o,
    rtb_SumU, sfmc_V_battUMaxThr1, 2, &SFM_DW.Subsytem8);

  /* End of Outputs for SubSystem: '<S28>/Subsytem8' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsystem7' */
  rtb_RelationalOperator1_o = SFM_Subsystem5(sfmd_flg_volFlt,
    rtb_RelationalOperator1);

  /* End of Outputs for SubSystem: '<S28>/Subsystem7' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem7' */
  /* Constant: '<S28>/Constant9' incorporates:
   *  Constant: '<S28>/Constant7'
   *  Constant: '<S28>/Constant8'
   */
  rtb_RelationalOperator1_o = SFM_Subsytem7(1, rtb_RelationalOperator1_o,
    rtb_SumU, sfmc_V_battUMinThr2, 2, &SFM_DW.Subsytem7);

  /* End of Outputs for SubSystem: '<S28>/Subsytem7' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsystem8' */
  rtb_RelationalOperator_et = SFM_Subsystem5(sfmd_flg_volFlt,
    rtb_RelationalOperator1);

  /* End of Outputs for SubSystem: '<S28>/Subsystem8' */

  /* Outputs for Atomic SubSystem: '<S28>/Subsytem9' */
  /* Constant: '<S28>/Constant6' incorporates:
   *  Constant: '<S28>/Constant4'
   *  Constant: '<S28>/Constant5'
   */
  rtb_RelationalOperator_et = SFM_Subsytem7(1, rtb_RelationalOperator_et,
    rtb_SumU, sfmc_V_battUMinThr1, 2, &SFM_DW.Subsytem9);

  /* End of Outputs for SubSystem: '<S28>/Subsytem9' */

  /* Chart: '<S19>/ArrMin' incorporates:
   *  Constant: '<S19>/Constant'
   *  Inport: '<Root>/ihv_T_modT'
   */
  i = 0U;
  sfmd_T_modTMax = ihv_T_modT[0];
  while (i < cmnc_num_modTNum) {
    if (sfmd_T_modTMax < ihv_T_modT[i]) {
      sfmd_T_modTMax = ihv_T_modT[i];
    }

    i++;
  }

  /* End of Chart: '<S19>/ArrMin' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem' */
  /* Constant: '<S27>/Constant28' incorporates:
   *  Constant: '<S27>/Constant25'
   *  Constant: '<S27>/Constant27'
   *  Logic: '<S27>/Logical Operator5'
   */
  rtb_RelationalOperator1_p = SFM_Subsytem(1, !rtb_RelationalOperator1,
    sfmd_T_modTMax, sfmc_T_modTMaxThr2, 2, &SFM_DW.Subsytem_j);

  /* End of Outputs for SubSystem: '<S27>/Subsytem' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem2' */
  /* Constant: '<S27>/Constant26' incorporates:
   *  Constant: '<S27>/Constant23'
   *  Constant: '<S27>/Constant24'
   *  Logic: '<S27>/Logical Operator1'
   */
  rtb_RelationalOperator1_a = SFM_Subsytem(1, !rtb_RelationalOperator1,
    sfmd_T_modTMax, sfmc_T_modTMaxThr1, 2, &SFM_DW.Subsytem2);

  /* End of Outputs for SubSystem: '<S27>/Subsytem2' */

  /* Chart: '<S20>/ArrMin' incorporates:
   *  Constant: '<S20>/Constant'
   *  Inport: '<Root>/ihv_T_modT'
   */
  i = 0U;
  sfmd_T_modTMin = ihv_T_modT[0];
  while (i < cmnc_num_modTNum) {
    if (sfmd_T_modTMin > ihv_T_modT[i]) {
      sfmd_T_modTMin = ihv_T_modT[i];
    }

    i++;
  }

  /* End of Chart: '<S20>/ArrMin' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem1' */
  /* Constant: '<S27>/Constant22' incorporates:
   *  Constant: '<S27>/Constant20'
   *  Constant: '<S27>/Constant21'
   *  Logic: '<S27>/Logical Operator3'
   */
  rtb_RelationalOperator1_i = SFM_Subsytem1(1, !rtb_RelationalOperator1,
    sfmd_T_modTMin, sfmc_T_modTMinThr2, 2, &SFM_DW.Subsytem1_e);

  /* End of Outputs for SubSystem: '<S27>/Subsytem1' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem3' */
  /* Constant: '<S27>/Constant19' incorporates:
   *  Constant: '<S27>/Constant10'
   *  Constant: '<S27>/Constant18'
   *  Logic: '<S27>/Logical Operator7'
   */
  rtb_RelationalOperator1_d = SFM_Subsytem1(1, !rtb_RelationalOperator1,
    sfmd_T_modTMin, sfmc_T_modTMinThr1, 2, &SFM_DW.Subsytem3);

  /* End of Outputs for SubSystem: '<S27>/Subsytem3' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem4' */
  /* Constant: '<S27>/Constant14' incorporates:
   *  Constant: '<S27>/Constant12'
   *  Constant: '<S27>/Constant13'
   *  Logic: '<S27>/Logical Operator4'
   *  Sum: '<S27>/Add'
   */
  rtb_RelationalOperator1_bb = SFM_Subsytem(1, !rtb_RelationalOperator1,
    (int16_T)(sfmd_T_modTMax - sfmd_T_modTMin), sfmc_T_modTDiffThr2, 2,
    &SFM_DW.Subsytem4);

  /* End of Outputs for SubSystem: '<S27>/Subsytem4' */

  /* Outputs for Atomic SubSystem: '<S27>/Subsytem5' */
  /* Constant: '<S27>/Constant1' incorporates:
   *  Constant: '<S27>/Constant2'
   *  Constant: '<S27>/Constant3'
   *  Logic: '<S27>/Logical Operator10'
   *  Sum: '<S27>/Add1'
   */
  rtb_RelationalOperator1_gr = SFM_Subsytem(1, !rtb_RelationalOperator1,
    (int16_T)(sfmd_T_modTMax - sfmd_T_modTMin), sfmc_T_modTDiffThr1, 2,
    &SFM_DW.Subsytem5);

  /* End of Outputs for SubSystem: '<S27>/Subsytem5' */

  /* Switch: '<S14>/Switch' incorporates:
   *  Inport: '<Root>/ihd_flg_currFlt'
   */
  if (ihd_flg_currFlt) {
    /* Switch: '<S14>/Switch' incorporates:
     *  Constant: '<S14>/Constant'
     */
    sfmd_I_curr = 0;
  } else {
    /* Switch: '<S14>/Switch' incorporates:
     *  Inport: '<Root>/ihd_I_curr'
     */
    sfmd_I_curr = ihd_I_curr;
  }

  /* End of Switch: '<S14>/Switch' */

  /* Outputs for Atomic SubSystem: '<S24>/Subsytem' */
  /* Saturate: '<S29>/Saturation' incorporates:
   *  Constant: '<S29>/Constant1'
   *  Sum: '<S29>/Add'
   *  UnitDelay: '<S29>/delay'
   */
  if ((uint8_T)(SFM_DW.delay_DSTATE_j + 1U) < 200) {
    i = (uint8_T)(SFM_DW.delay_DSTATE_j + 1U);
  } else {
    i = 200U;
  }

  /* End of Saturate: '<S29>/Saturation' */

  /* Product: '<S29>/Product' incorporates:
   *  Constant: '<S24>/Constant27'
   *  Logic: '<S24>/Logical Operator2'
   *  Logic: '<S29>/Logical Operator1'
   *  RelationalOperator: '<S29>/Relational Operator'
   *  Switch: '<S14>/Switch'
   *  UnitDelay: '<S29>/delay'
   */
  SFM_DW.delay_DSTATE_j = (uint8_T)((!rtb_RelationalOperator1) && (sfmd_I_curr >=
    sfmc_I_chrgCurrOverThr) ? (int32_T)i : 0);

  /* SignalConversion generated from: '<S5>/ SFunction ' incorporates:
   *  Chart: '<S3>/FltCodeArry'
   *  Constant: '<S24>/Constant25'
   *  RelationalOperator: '<S29>/Relational Operator1'
   */
  rtb_TmpSignalConversionAtSFun_a[130] = (i > 2);

  /* End of Outputs for SubSystem: '<S24>/Subsytem' */

  /* Outputs for Atomic SubSystem: '<S24>/Subsytem1' */
  /* Saturate: '<S30>/Saturation' incorporates:
   *  Constant: '<S30>/Constant2'
   *  Sum: '<S30>/Add'
   *  UnitDelay: '<S30>/delay'
   */
  if ((uint8_T)(SFM_DW.delay_DSTATE + 1U) < 200) {
    i = (uint8_T)(SFM_DW.delay_DSTATE + 1U);
  } else {
    i = 200U;
  }

  /* End of Saturate: '<S30>/Saturation' */

  /* Product: '<S30>/Product' incorporates:
   *  Constant: '<S24>/Constant10'
   *  Logic: '<S24>/Logical Operator1'
   *  Logic: '<S30>/Logical Operator'
   *  RelationalOperator: '<S30>/Relational Operator'
   *  Switch: '<S14>/Switch'
   *  UnitDelay: '<S30>/delay'
   */
  SFM_DW.delay_DSTATE = (uint8_T)((!rtb_RelationalOperator1) && (sfmd_I_curr <=
    sfmc_I_dischrgCurrOverThr) ? (int32_T)i : 0);

  /* End of Outputs for SubSystem: '<S24>/Subsytem1' */

  /* SignalConversion generated from: '<S5>/ SFunction ' incorporates:
   *  Chart: '<S3>/FltCodeArry'
   *  Constant: '<S10>/Constant1'
   *  Constant: '<S10>/Constant10'
   *  Constant: '<S10>/Constant12'
   *  Constant: '<S10>/Constant13'
   *  Constant: '<S10>/Constant14'
   *  Constant: '<S10>/Constant15'
   *  Constant: '<S10>/Constant16'
   *  Constant: '<S10>/Constant17'
   *  Constant: '<S10>/Constant18'
   *  Constant: '<S10>/Constant19'
   *  Constant: '<S10>/Constant2'
   *  Constant: '<S10>/Constant20'
   *  Constant: '<S10>/Constant21'
   *  Constant: '<S10>/Constant22'
   *  Constant: '<S10>/Constant23'
   *  Constant: '<S10>/Constant24'
   *  Constant: '<S10>/Constant25'
   *  Constant: '<S10>/Constant26'
   *  Constant: '<S10>/Constant27'
   *  Constant: '<S10>/Constant28'
   *  Constant: '<S10>/Constant29'
   *  Constant: '<S10>/Constant3'
   *  Constant: '<S10>/Constant4'
   *  Constant: '<S10>/Constant5'
   *  Constant: '<S10>/Constant6'
   *  Constant: '<S10>/Constant7'
   *  Constant: '<S10>/Constant8'
   *  Constant: '<S10>/Constant9'
   *  Constant: '<S12>/Constant'
   *  Constant: '<S12>/Constant1'
   *  Constant: '<S12>/Constant2'
   *  Constant: '<S12>/Constant3'
   *  Constant: '<S12>/Constant4'
   *  Constant: '<S12>/Constant5'
   *  Constant: '<S12>/Constant6'
   *  Constant: '<S12>/Constant7'
   *  Constant: '<S12>/Constant8'
   *  Constant: '<S12>/Constant9'
   *  Constant: '<S15>/Constant11'
   *  Constant: '<S15>/Constant12'
   *  Constant: '<S15>/Constant13'
   *  Constant: '<S15>/Constant14'
   *  Constant: '<S15>/Constant15'
   *  Constant: '<S15>/Constant16'
   *  Constant: '<S15>/Constant17'
   *  Constant: '<S15>/Constant18'
   *  Constant: '<S15>/Constant19'
   *  Constant: '<S15>/Constant20'
   *  Constant: '<S15>/Constant21'
   *  Constant: '<S15>/Constant4'
   *  Constant: '<S15>/Constant5'
   *  Constant: '<S15>/Constant6'
   *  Constant: '<S15>/Constant7'
   *  Constant: '<S15>/Constant8'
   *  Constant: '<S15>/Constant9'
   *  Constant: '<S16>/Constant'
   *  Constant: '<S16>/Constant1'
   *  Constant: '<S16>/Constant2'
   *  Constant: '<S16>/Constant3'
   *  Constant: '<S16>/Constant4'
   *  Constant: '<S16>/Constant5'
   *  Constant: '<S16>/Constant6'
   *  Constant: '<S16>/Constant7'
   *  Constant: '<S17>/Constant1'
   *  Constant: '<S24>/Constant1'
   *  Constant: '<S24>/Constant2'
   *  Constant: '<S24>/Constant3'
   *  Constant: '<S24>/Constant4'
   *  Constant: '<S24>/Constant5'
   *  Constant: '<S24>/Constant6'
   *  Constant: '<S24>/Constant7'
   *  Constant: '<S24>/Constant8'
   *  Constant: '<S24>/Constant9'
   *  Constant: '<S25>/Constant1'
   *  Constant: '<S25>/Constant2'
   *  Constant: '<S25>/Constant3'
   *  Constant: '<S25>/Constant4'
   *  Constant: '<S25>/Constant5'
   *  Constant: '<S25>/Constant6'
   *  Constant: '<S25>/Constant7'
   *  Constant: '<S25>/Constant8'
   *  Constant: '<S25>/Constant9'
   *  Constant: '<S26>/Constant'
   *  Constant: '<S27>/Constant'
   *  Constant: '<S27>/Constant11'
   *  Constant: '<S27>/Constant15'
   *  Constant: '<S27>/Constant16'
   *  Constant: '<S27>/Constant17'
   *  Constant: '<S27>/Constant29'
   *  Constant: '<S27>/Constant30'
   *  Constant: '<S27>/Constant31'
   *  Constant: '<S27>/Constant32'
   *  Constant: '<S27>/Constant33'
   *  Constant: '<S27>/Constant34'
   *  Constant: '<S27>/Constant35'
   *  Constant: '<S27>/Constant36'
   *  Constant: '<S27>/Constant37'
   *  Constant: '<S27>/Constant38'
   *  Constant: '<S27>/Constant39'
   *  Constant: '<S27>/Constant4'
   *  Constant: '<S27>/Constant40'
   *  Constant: '<S27>/Constant41'
   *  Constant: '<S27>/Constant5'
   *  Constant: '<S27>/Constant6'
   *  Constant: '<S27>/Constant7'
   *  Constant: '<S27>/Constant8'
   *  Constant: '<S27>/Constant9'
   *  Constant: '<S28>/Constant'
   *  Constant: '<S28>/Constant31'
   *  Constant: '<S28>/Constant32'
   *  Constant: '<S28>/Constant33'
   *  Constant: '<S28>/Constant34'
   *  Constant: '<S28>/Constant35'
   *  Constant: '<S28>/Constant36'
   *  Constant: '<S28>/Constant37'
   *  Constant: '<S28>/Constant38'
   *  Constant: '<S28>/Constant39'
   *  Constant: '<S6>/Constant'
   *  Constant: '<S8>/Constant'
   *  Constant: '<S8>/Constant1'
   *  Constant: '<S8>/Constant2'
   *  Constant: '<S8>/Constant3'
   *  Constant: '<S8>/Constant4'
   *  Constant: '<S9>/Constant1'
   *  Constant: '<S9>/Constant10'
   *  Constant: '<S9>/Constant2'
   *  Constant: '<S9>/Constant3'
   *  Constant: '<S9>/Constant4'
   *  Constant: '<S9>/Constant5'
   *  Constant: '<S9>/Constant7'
   *  Constant: '<S9>/Constant8'
   *  Constant: '<S9>/Constant9'
   *  Inport: '<Root>/ihd_flg_chrgMosClosFlt'
   *  Inport: '<Root>/ihd_flg_disChrgMosClosFlt'
   *  Logic: '<S13>/Logical Operator1'
   *  Logic: '<S27>/Logical Operator12'
   *  Logic: '<S27>/Logical Operator13'
   *  Logic: '<S27>/Logical Operator2'
   *  Logic: '<S27>/Logical Operator6'
   *  Logic: '<S27>/Logical Operator8'
   *  Logic: '<S27>/Logical Operator9'
   *  Logic: '<S28>/Logical Operator'
   *  Logic: '<S28>/Logical Operator10'
   *  Logic: '<S28>/Logical Operator11'
   *  Logic: '<S28>/Logical Operator12'
   *  Logic: '<S28>/Logical Operator13'
   *  Logic: '<S28>/Logical Operator14'
   *  Logic: '<S28>/Logical Operator15'
   *  Logic: '<S28>/Logical Operator4'
   *  Logic: '<S28>/Logical Operator7'
   *  Logic: '<S28>/Logical Operator8'
   *  RelationalOperator: '<S30>/Relational Operator1'
   */
  rtb_TmpSignalConversionAtSFun_a[0] = rtb_RelationalOperator1;
  rtb_TmpSignalConversionAtSFun_a[1] = false;
  rtb_TmpSignalConversionAtSFun_a[2] = false;
  rtb_TmpSignalConversionAtSFun_a[3] = false;
  rtb_TmpSignalConversionAtSFun_a[4] = false;
  rtb_TmpSignalConversionAtSFun_a[5] = false;
  rtb_TmpSignalConversionAtSFun_a[6] = false;
  rtb_TmpSignalConversionAtSFun_a[7] = false;
  rtb_TmpSignalConversionAtSFun_a[8] = false;
  rtb_TmpSignalConversionAtSFun_a[9] = false;
  rtb_TmpSignalConversionAtSFun_a[10] = false;
  rtb_TmpSignalConversionAtSFun_a[11] = false;
  rtb_TmpSignalConversionAtSFun_a[12] = false;
  rtb_TmpSignalConversionAtSFun_a[13] = false;
  rtb_TmpSignalConversionAtSFun_a[14] = false;
  rtb_TmpSignalConversionAtSFun_a[15] = false;
  rtb_TmpSignalConversionAtSFun_a[16] = false;
  rtb_TmpSignalConversionAtSFun_a[17] = false;
  rtb_TmpSignalConversionAtSFun_a[18] = false;
  rtb_TmpSignalConversionAtSFun_a[19] = false;
  rtb_TmpSignalConversionAtSFun_a[20] = false;
  rtb_TmpSignalConversionAtSFun_a[21] = ihd_flg_chrgMosClosFlt;
  rtb_TmpSignalConversionAtSFun_a[22] = false;
  rtb_TmpSignalConversionAtSFun_a[23] = ihd_flg_dischrgMosClosFlt;
  rtb_TmpSignalConversionAtSFun_a[24] = false;
  rtb_TmpSignalConversionAtSFun_a[25] = false;
  rtb_TmpSignalConversionAtSFun_a[26] = false;
  rtb_TmpSignalConversionAtSFun_a[27] = false;
  rtb_TmpSignalConversionAtSFun_a[28] = false;
  rtb_TmpSignalConversionAtSFun_a[29] = false;
  rtb_TmpSignalConversionAtSFun_a[30] = false;
  rtb_TmpSignalConversionAtSFun_a[31] = false;
  rtb_TmpSignalConversionAtSFun_a[32] = false;
  rtb_TmpSignalConversionAtSFun_a[33] = false;
  rtb_TmpSignalConversionAtSFun_a[34] = false;
  rtb_TmpSignalConversionAtSFun_a[35] = false;
  rtb_TmpSignalConversionAtSFun_a[36] = false;
  rtb_TmpSignalConversionAtSFun_a[37] = false;
  rtb_TmpSignalConversionAtSFun_a[38] = false;
  rtb_TmpSignalConversionAtSFun_a[39] = false;
  rtb_TmpSignalConversionAtSFun_a[40] = false;
  rtb_TmpSignalConversionAtSFun_a[41] = false;
  rtb_TmpSignalConversionAtSFun_a[42] = false;
  rtb_TmpSignalConversionAtSFun_a[43] = false;
  rtb_TmpSignalConversionAtSFun_a[44] = false;
  rtb_TmpSignalConversionAtSFun_a[45] = false;
  rtb_TmpSignalConversionAtSFun_a[46] = false;
  rtb_TmpSignalConversionAtSFun_a[47] = false;
  rtb_TmpSignalConversionAtSFun_a[48] = false;
  rtb_TmpSignalConversionAtSFun_a[49] = false;
  rtb_TmpSignalConversionAtSFun_a[50] = false;
  rtb_TmpSignalConversionAtSFun_a[51] = tmp;
  rtb_TmpSignalConversionAtSFun_a[52] = sfmv_flg_TFlt;
  rtb_TmpSignalConversionAtSFun_a[53] = false;
  rtb_TmpSignalConversionAtSFun_a[54] = false;
  rtb_TmpSignalConversionAtSFun_a[55] = false;
  rtb_TmpSignalConversionAtSFun_a[56] = false;
  rtb_TmpSignalConversionAtSFun_a[57] = false;
  rtb_TmpSignalConversionAtSFun_a[58] = false;
  rtb_TmpSignalConversionAtSFun_a[59] = false;
  rtb_TmpSignalConversionAtSFun_a[60] = false;
  rtb_TmpSignalConversionAtSFun_a[61] = false;
  rtb_TmpSignalConversionAtSFun_a[62] = false;
  rtb_TmpSignalConversionAtSFun_a[63] = false;
  rtb_TmpSignalConversionAtSFun_a[64] = false;
  rtb_TmpSignalConversionAtSFun_a[65] = false;
  rtb_TmpSignalConversionAtSFun_a[66] = false;
  rtb_TmpSignalConversionAtSFun_a[67] = false;
  rtb_TmpSignalConversionAtSFun_a[68] = false;
  rtb_TmpSignalConversionAtSFun_a[69] = false;
  rtb_TmpSignalConversionAtSFun_a[70] = sfmd_flg_currFlt;
  rtb_TmpSignalConversionAtSFun_a[71] = false;
  rtb_TmpSignalConversionAtSFun_a[72] = false;
  rtb_TmpSignalConversionAtSFun_a[73] = false;
  rtb_TmpSignalConversionAtSFun_a[74] = false;
  rtb_TmpSignalConversionAtSFun_a[75] = false;
  rtb_TmpSignalConversionAtSFun_a[76] = false;
  rtb_TmpSignalConversionAtSFun_a[77] = false;
  rtb_TmpSignalConversionAtSFun_a[78] = false;
  rtb_TmpSignalConversionAtSFun_a[79] = false;
  rtb_TmpSignalConversionAtSFun_a[80] = rtb_RelationalOperator1_ep;
  rtb_TmpSignalConversionAtSFun_a[81] = (rtb_RelationalOperator1_j &&
    (!rtb_RelationalOperator1_ep));
  rtb_TmpSignalConversionAtSFun_a[82] = rtb_RelationalOperator1_di;
  rtb_TmpSignalConversionAtSFun_a[83] = (rtb_RelationalOperator1_l &&
    (!rtb_RelationalOperator1_di));
  rtb_TmpSignalConversionAtSFun_a[84] = rtb_RelationalOperator1_lf;
  rtb_TmpSignalConversionAtSFun_a[85] = (rtb_RelationalOperator1_eg &&
    (!rtb_RelationalOperator1_lf));
  rtb_TmpSignalConversionAtSFun_a[86] = rtb_RelationalOperator1_fg;
  rtb_TmpSignalConversionAtSFun_a[87] = (rtb_RelationalOperator1_it &&
    (!rtb_RelationalOperator1_fg));
  rtb_TmpSignalConversionAtSFun_a[88] = rtb_RelationalOperator1_o;
  rtb_TmpSignalConversionAtSFun_a[89] = (rtb_RelationalOperator_et &&
    (!rtb_RelationalOperator1_o));
  rtb_TmpSignalConversionAtSFun_a[90] = false;
  rtb_TmpSignalConversionAtSFun_a[91] = false;
  rtb_TmpSignalConversionAtSFun_a[92] = false;
  rtb_TmpSignalConversionAtSFun_a[93] = false;
  rtb_TmpSignalConversionAtSFun_a[94] = false;
  rtb_TmpSignalConversionAtSFun_a[95] = false;
  rtb_TmpSignalConversionAtSFun_a[96] = false;
  rtb_TmpSignalConversionAtSFun_a[97] = false;
  rtb_TmpSignalConversionAtSFun_a[98] = false;
  rtb_TmpSignalConversionAtSFun_a[99] = false;
  rtb_TmpSignalConversionAtSFun_a[100] = rtb_RelationalOperator1_p;
  rtb_TmpSignalConversionAtSFun_a[101] = (rtb_RelationalOperator1_a &&
    (!rtb_RelationalOperator1_p));
  rtb_TmpSignalConversionAtSFun_a[102] = rtb_RelationalOperator1_i;
  rtb_TmpSignalConversionAtSFun_a[103] = (rtb_RelationalOperator1_d &&
    (!rtb_RelationalOperator1_i));
  rtb_TmpSignalConversionAtSFun_a[104] = rtb_RelationalOperator1_bb;
  rtb_TmpSignalConversionAtSFun_a[105] = (rtb_RelationalOperator1_gr &&
    (!rtb_RelationalOperator1_bb));
  rtb_TmpSignalConversionAtSFun_a[106] = false;
  rtb_TmpSignalConversionAtSFun_a[107] = false;
  rtb_TmpSignalConversionAtSFun_a[108] = false;
  rtb_TmpSignalConversionAtSFun_a[109] = false;
  rtb_TmpSignalConversionAtSFun_a[110] = false;
  rtb_TmpSignalConversionAtSFun_a[111] = false;
  rtb_TmpSignalConversionAtSFun_a[112] = false;
  rtb_TmpSignalConversionAtSFun_a[113] = false;
  rtb_TmpSignalConversionAtSFun_a[114] = false;
  rtb_TmpSignalConversionAtSFun_a[115] = false;
  rtb_TmpSignalConversionAtSFun_a[116] = false;
  rtb_TmpSignalConversionAtSFun_a[117] = false;
  rtb_TmpSignalConversionAtSFun_a[118] = false;
  rtb_TmpSignalConversionAtSFun_a[119] = false;
  rtb_TmpSignalConversionAtSFun_a[120] = false;
  rtb_TmpSignalConversionAtSFun_a[121] = false;
  rtb_TmpSignalConversionAtSFun_a[122] = false;
  rtb_TmpSignalConversionAtSFun_a[123] = false;
  rtb_TmpSignalConversionAtSFun_a[124] = false;
  rtb_TmpSignalConversionAtSFun_a[125] = false;
  rtb_TmpSignalConversionAtSFun_a[126] = false;
  rtb_TmpSignalConversionAtSFun_a[127] = false;
  rtb_TmpSignalConversionAtSFun_a[128] = false;
  rtb_TmpSignalConversionAtSFun_a[129] = false;

  /* Outputs for Atomic SubSystem: '<S24>/Subsytem1' */
  rtb_TmpSignalConversionAtSFun_a[131] = (i > 2);

  /* End of Outputs for SubSystem: '<S24>/Subsytem1' */
  rtb_TmpSignalConversionAtSFun_a[132] = false;
  rtb_TmpSignalConversionAtSFun_a[133] = false;
  rtb_TmpSignalConversionAtSFun_a[134] = false;
  rtb_TmpSignalConversionAtSFun_a[135] = false;
  rtb_TmpSignalConversionAtSFun_a[136] = false;
  rtb_TmpSignalConversionAtSFun_a[137] = false;
  rtb_TmpSignalConversionAtSFun_a[138] = false;
  rtb_TmpSignalConversionAtSFun_a[139] = false;
  rtb_TmpSignalConversionAtSFun_a[140] = false;
  rtb_TmpSignalConversionAtSFun_a[141] = false;
  rtb_TmpSignalConversionAtSFun_a[142] = false;
  rtb_TmpSignalConversionAtSFun_a[143] = false;
  rtb_TmpSignalConversionAtSFun_a[144] = false;
  rtb_TmpSignalConversionAtSFun_a[145] = false;
  rtb_TmpSignalConversionAtSFun_a[146] = false;
  rtb_TmpSignalConversionAtSFun_a[147] = false;
  rtb_TmpSignalConversionAtSFun_a[148] = false;
  rtb_TmpSignalConversionAtSFun_a[149] = false;
  rtb_TmpSignalConversionAtSFun_a[150] = false;
  rtb_TmpSignalConversionAtSFun_a[151] = false;
  rtb_TmpSignalConversionAtSFun_a[152] = false;
  rtb_TmpSignalConversionAtSFun_a[153] = false;
  rtb_TmpSignalConversionAtSFun_a[154] = false;

  /* SignalConversion generated from: '<S5>/ SFunction ' incorporates:
   *  Chart: '<S3>/FltCodeArry'
   *  Constant: '<S3>/Constant1'
   *  Constant: '<S3>/Constant10'
   *  Constant: '<S3>/Constant100'
   *  Constant: '<S3>/Constant101'
   *  Constant: '<S3>/Constant102'
   *  Constant: '<S3>/Constant103'
   *  Constant: '<S3>/Constant104'
   *  Constant: '<S3>/Constant105'
   *  Constant: '<S3>/Constant106'
   *  Constant: '<S3>/Constant107'
   *  Constant: '<S3>/Constant108'
   *  Constant: '<S3>/Constant109'
   *  Constant: '<S3>/Constant11'
   *  Constant: '<S3>/Constant110'
   *  Constant: '<S3>/Constant111'
   *  Constant: '<S3>/Constant112'
   *  Constant: '<S3>/Constant113'
   *  Constant: '<S3>/Constant114'
   *  Constant: '<S3>/Constant115'
   *  Constant: '<S3>/Constant116'
   *  Constant: '<S3>/Constant117'
   *  Constant: '<S3>/Constant118'
   *  Constant: '<S3>/Constant119'
   *  Constant: '<S3>/Constant12'
   *  Constant: '<S3>/Constant120'
   *  Constant: '<S3>/Constant121'
   *  Constant: '<S3>/Constant122'
   *  Constant: '<S3>/Constant123'
   *  Constant: '<S3>/Constant124'
   *  Constant: '<S3>/Constant125'
   *  Constant: '<S3>/Constant126'
   *  Constant: '<S3>/Constant127'
   *  Constant: '<S3>/Constant128'
   *  Constant: '<S3>/Constant129'
   *  Constant: '<S3>/Constant13'
   *  Constant: '<S3>/Constant130'
   *  Constant: '<S3>/Constant131'
   *  Constant: '<S3>/Constant132'
   *  Constant: '<S3>/Constant133'
   *  Constant: '<S3>/Constant134'
   *  Constant: '<S3>/Constant135'
   *  Constant: '<S3>/Constant136'
   *  Constant: '<S3>/Constant137'
   *  Constant: '<S3>/Constant138'
   *  Constant: '<S3>/Constant139'
   *  Constant: '<S3>/Constant14'
   *  Constant: '<S3>/Constant140'
   *  Constant: '<S3>/Constant141'
   *  Constant: '<S3>/Constant142'
   *  Constant: '<S3>/Constant143'
   *  Constant: '<S3>/Constant144'
   *  Constant: '<S3>/Constant145'
   *  Constant: '<S3>/Constant146'
   *  Constant: '<S3>/Constant147'
   *  Constant: '<S3>/Constant148'
   *  Constant: '<S3>/Constant149'
   *  Constant: '<S3>/Constant15'
   *  Constant: '<S3>/Constant150'
   *  Constant: '<S3>/Constant151'
   *  Constant: '<S3>/Constant152'
   *  Constant: '<S3>/Constant153'
   *  Constant: '<S3>/Constant154'
   *  Constant: '<S3>/Constant155'
   *  Constant: '<S3>/Constant157'
   *  Constant: '<S3>/Constant158'
   *  Constant: '<S3>/Constant159'
   *  Constant: '<S3>/Constant16'
   *  Constant: '<S3>/Constant160'
   *  Constant: '<S3>/Constant17'
   *  Constant: '<S3>/Constant18'
   *  Constant: '<S3>/Constant19'
   *  Constant: '<S3>/Constant20'
   *  Constant: '<S3>/Constant21'
   *  Constant: '<S3>/Constant22'
   *  Constant: '<S3>/Constant23'
   *  Constant: '<S3>/Constant24'
   *  Constant: '<S3>/Constant25'
   *  Constant: '<S3>/Constant26'
   *  Constant: '<S3>/Constant27'
   *  Constant: '<S3>/Constant28'
   *  Constant: '<S3>/Constant29'
   *  Constant: '<S3>/Constant30'
   *  Constant: '<S3>/Constant31'
   *  Constant: '<S3>/Constant32'
   *  Constant: '<S3>/Constant33'
   *  Constant: '<S3>/Constant34'
   *  Constant: '<S3>/Constant35'
   *  Constant: '<S3>/Constant36'
   *  Constant: '<S3>/Constant37'
   *  Constant: '<S3>/Constant38'
   *  Constant: '<S3>/Constant39'
   *  Constant: '<S3>/Constant4'
   *  Constant: '<S3>/Constant40'
   *  Constant: '<S3>/Constant41'
   *  Constant: '<S3>/Constant42'
   *  Constant: '<S3>/Constant43'
   *  Constant: '<S3>/Constant44'
   *  Constant: '<S3>/Constant45'
   *  Constant: '<S3>/Constant46'
   *  Constant: '<S3>/Constant47'
   *  Constant: '<S3>/Constant48'
   *  Constant: '<S3>/Constant49'
   *  Constant: '<S3>/Constant5'
   *  Constant: '<S3>/Constant50'
   *  Constant: '<S3>/Constant51'
   *  Constant: '<S3>/Constant52'
   *  Constant: '<S3>/Constant53'
   *  Constant: '<S3>/Constant54'
   *  Constant: '<S3>/Constant55'
   *  Constant: '<S3>/Constant56'
   *  Constant: '<S3>/Constant57'
   *  Constant: '<S3>/Constant58'
   *  Constant: '<S3>/Constant59'
   *  Constant: '<S3>/Constant6'
   *  Constant: '<S3>/Constant60'
   *  Constant: '<S3>/Constant61'
   *  Constant: '<S3>/Constant62'
   *  Constant: '<S3>/Constant63'
   *  Constant: '<S3>/Constant64'
   *  Constant: '<S3>/Constant65'
   *  Constant: '<S3>/Constant66'
   *  Constant: '<S3>/Constant67'
   *  Constant: '<S3>/Constant68'
   *  Constant: '<S3>/Constant69'
   *  Constant: '<S3>/Constant7'
   *  Constant: '<S3>/Constant70'
   *  Constant: '<S3>/Constant71'
   *  Constant: '<S3>/Constant72'
   *  Constant: '<S3>/Constant73'
   *  Constant: '<S3>/Constant74'
   *  Constant: '<S3>/Constant75'
   *  Constant: '<S3>/Constant76'
   *  Constant: '<S3>/Constant77'
   *  Constant: '<S3>/Constant78'
   *  Constant: '<S3>/Constant79'
   *  Constant: '<S3>/Constant8'
   *  Constant: '<S3>/Constant80'
   *  Constant: '<S3>/Constant81'
   *  Constant: '<S3>/Constant84'
   *  Constant: '<S3>/Constant85'
   *  Constant: '<S3>/Constant86'
   *  Constant: '<S3>/Constant87'
   *  Constant: '<S3>/Constant88'
   *  Constant: '<S3>/Constant89'
   *  Constant: '<S3>/Constant9'
   *  Constant: '<S3>/Constant90'
   *  Constant: '<S3>/Constant91'
   *  Constant: '<S3>/Constant92'
   *  Constant: '<S3>/Constant93'
   *  Constant: '<S3>/Constant94'
   *  Constant: '<S3>/Constant95'
   *  Constant: '<S3>/Constant96'
   *  Constant: '<S3>/Constant97'
   *  Constant: '<S3>/Constant98'
   *  Constant: '<S3>/Constant99'
   */
  rtb_TmpSignalConversionAtSFunct[0] = 2U;
  rtb_TmpSignalConversionAtSFunct[1] = 2U;
  rtb_TmpSignalConversionAtSFunct[2] = 2U;
  rtb_TmpSignalConversionAtSFunct[3] = 2U;
  rtb_TmpSignalConversionAtSFunct[4] = 4U;
  rtb_TmpSignalConversionAtSFunct[5] = 0U;
  rtb_TmpSignalConversionAtSFunct[6] = 0U;
  rtb_TmpSignalConversionAtSFunct[7] = 0U;
  rtb_TmpSignalConversionAtSFunct[8] = 0U;
  rtb_TmpSignalConversionAtSFunct[9] = 0U;
  rtb_TmpSignalConversionAtSFunct[10] = 5U;
  rtb_TmpSignalConversionAtSFunct[11] = 5U;
  rtb_TmpSignalConversionAtSFunct[12] = 2U;
  rtb_TmpSignalConversionAtSFunct[13] = 5U;
  rtb_TmpSignalConversionAtSFunct[14] = 3U;
  rtb_TmpSignalConversionAtSFunct[15] = 0U;
  rtb_TmpSignalConversionAtSFunct[16] = 0U;
  rtb_TmpSignalConversionAtSFunct[17] = 0U;
  rtb_TmpSignalConversionAtSFunct[18] = 0U;
  rtb_TmpSignalConversionAtSFunct[19] = 0U;
  rtb_TmpSignalConversionAtSFunct[20] = 5U;
  rtb_TmpSignalConversionAtSFunct[21] = 4U;
  rtb_TmpSignalConversionAtSFunct[22] = 2U;
  rtb_TmpSignalConversionAtSFunct[23] = 4U;
  rtb_TmpSignalConversionAtSFunct[24] = 2U;
  rtb_TmpSignalConversionAtSFunct[25] = 3U;
  rtb_TmpSignalConversionAtSFunct[26] = 3U;
  rtb_TmpSignalConversionAtSFunct[27] = 3U;
  rtb_TmpSignalConversionAtSFunct[28] = 3U;
  rtb_TmpSignalConversionAtSFunct[29] = 5U;
  rtb_TmpSignalConversionAtSFunct[30] = 2U;
  rtb_TmpSignalConversionAtSFunct[31] = 4U;
  rtb_TmpSignalConversionAtSFunct[32] = 0U;
  rtb_TmpSignalConversionAtSFunct[33] = 0U;
  rtb_TmpSignalConversionAtSFunct[34] = 0U;
  rtb_TmpSignalConversionAtSFunct[35] = 0U;
  rtb_TmpSignalConversionAtSFunct[36] = 0U;
  rtb_TmpSignalConversionAtSFunct[37] = 0U;
  rtb_TmpSignalConversionAtSFunct[38] = 0U;
  rtb_TmpSignalConversionAtSFunct[39] = 0U;
  rtb_TmpSignalConversionAtSFunct[40] = 0U;
  rtb_TmpSignalConversionAtSFunct[41] = 0U;
  rtb_TmpSignalConversionAtSFunct[42] = 0U;
  rtb_TmpSignalConversionAtSFunct[43] = 0U;
  rtb_TmpSignalConversionAtSFunct[44] = 0U;
  rtb_TmpSignalConversionAtSFunct[45] = 0U;
  rtb_TmpSignalConversionAtSFunct[46] = 0U;
  rtb_TmpSignalConversionAtSFunct[47] = 0U;
  rtb_TmpSignalConversionAtSFunct[48] = 0U;
  rtb_TmpSignalConversionAtSFunct[49] = 0U;
  rtb_TmpSignalConversionAtSFunct[50] = 2U;
  rtb_TmpSignalConversionAtSFunct[51] = 4U;
  rtb_TmpSignalConversionAtSFunct[52] = 4U;
  rtb_TmpSignalConversionAtSFunct[53] = 4U;
  rtb_TmpSignalConversionAtSFunct[54] = 4U;
  rtb_TmpSignalConversionAtSFunct[55] = 4U;
  rtb_TmpSignalConversionAtSFunct[56] = 4U;
  rtb_TmpSignalConversionAtSFunct[57] = 2U;
  rtb_TmpSignalConversionAtSFunct[58] = 2U;
  rtb_TmpSignalConversionAtSFunct[59] = 3U;
  rtb_TmpSignalConversionAtSFunct[60] = 0U;
  rtb_TmpSignalConversionAtSFunct[61] = 0U;
  rtb_TmpSignalConversionAtSFunct[62] = 0U;
  rtb_TmpSignalConversionAtSFunct[63] = 0U;
  rtb_TmpSignalConversionAtSFunct[64] = 0U;
  rtb_TmpSignalConversionAtSFunct[65] = 0U;
  rtb_TmpSignalConversionAtSFunct[66] = 0U;
  rtb_TmpSignalConversionAtSFunct[67] = 0U;
  rtb_TmpSignalConversionAtSFunct[68] = 0U;
  rtb_TmpSignalConversionAtSFunct[69] = 0U;
  rtb_TmpSignalConversionAtSFunct[70] = 4U;
  rtb_TmpSignalConversionAtSFunct[71] = 2U;
  rtb_TmpSignalConversionAtSFunct[72] = 0U;
  rtb_TmpSignalConversionAtSFunct[73] = 0U;
  rtb_TmpSignalConversionAtSFunct[74] = 0U;
  rtb_TmpSignalConversionAtSFunct[75] = 0U;
  rtb_TmpSignalConversionAtSFunct[76] = 0U;
  rtb_TmpSignalConversionAtSFunct[77] = 0U;
  rtb_TmpSignalConversionAtSFunct[78] = 0U;
  rtb_TmpSignalConversionAtSFunct[79] = 0U;
  rtb_TmpSignalConversionAtSFunct[80] = 4U;
  rtb_TmpSignalConversionAtSFunct[81] = 3U;
  rtb_TmpSignalConversionAtSFunct[82] = 4U;
  rtb_TmpSignalConversionAtSFunct[83] = 3U;
  rtb_TmpSignalConversionAtSFunct[84] = 3U;
  rtb_TmpSignalConversionAtSFunct[85] = 2U;
  rtb_TmpSignalConversionAtSFunct[86] = 4U;
  rtb_TmpSignalConversionAtSFunct[87] = 3U;
  rtb_TmpSignalConversionAtSFunct[88] = 4U;
  rtb_TmpSignalConversionAtSFunct[89] = 3U;
  rtb_TmpSignalConversionAtSFunct[90] = 0U;
  rtb_TmpSignalConversionAtSFunct[91] = 0U;
  rtb_TmpSignalConversionAtSFunct[92] = 0U;
  rtb_TmpSignalConversionAtSFunct[93] = 0U;
  rtb_TmpSignalConversionAtSFunct[94] = 0U;
  rtb_TmpSignalConversionAtSFunct[95] = 0U;
  rtb_TmpSignalConversionAtSFunct[96] = 0U;
  rtb_TmpSignalConversionAtSFunct[97] = 0U;
  rtb_TmpSignalConversionAtSFunct[98] = 0U;
  rtb_TmpSignalConversionAtSFunct[99] = 0U;
  rtb_TmpSignalConversionAtSFunct[100] = 4U;
  rtb_TmpSignalConversionAtSFunct[101] = 3U;
  rtb_TmpSignalConversionAtSFunct[102] = 4U;
  rtb_TmpSignalConversionAtSFunct[103] = 3U;
  rtb_TmpSignalConversionAtSFunct[104] = 3U;
  rtb_TmpSignalConversionAtSFunct[105] = 1U;
  rtb_TmpSignalConversionAtSFunct[106] = 4U;
  rtb_TmpSignalConversionAtSFunct[107] = 3U;
  rtb_TmpSignalConversionAtSFunct[108] = 4U;
  rtb_TmpSignalConversionAtSFunct[109] = 3U;
  rtb_TmpSignalConversionAtSFunct[110] = 4U;
  rtb_TmpSignalConversionAtSFunct[111] = 3U;
  rtb_TmpSignalConversionAtSFunct[112] = 4U;
  rtb_TmpSignalConversionAtSFunct[113] = 3U;
  rtb_TmpSignalConversionAtSFunct[114] = 4U;
  rtb_TmpSignalConversionAtSFunct[115] = 3U;
  rtb_TmpSignalConversionAtSFunct[116] = 1U;
  rtb_TmpSignalConversionAtSFunct[117] = 1U;
  rtb_TmpSignalConversionAtSFunct[118] = 0U;
  rtb_TmpSignalConversionAtSFunct[119] = 0U;
  rtb_TmpSignalConversionAtSFunct[120] = 0U;
  rtb_TmpSignalConversionAtSFunct[121] = 0U;
  rtb_TmpSignalConversionAtSFunct[122] = 0U;
  rtb_TmpSignalConversionAtSFunct[123] = 0U;
  rtb_TmpSignalConversionAtSFunct[124] = 0U;
  rtb_TmpSignalConversionAtSFunct[125] = 0U;
  rtb_TmpSignalConversionAtSFunct[126] = 0U;
  rtb_TmpSignalConversionAtSFunct[127] = 0U;
  rtb_TmpSignalConversionAtSFunct[128] = 0U;
  rtb_TmpSignalConversionAtSFunct[129] = 0U;
  rtb_TmpSignalConversionAtSFunct[130] = 4U;
  rtb_TmpSignalConversionAtSFunct[131] = 4U;
  rtb_TmpSignalConversionAtSFunct[132] = 3U;
  rtb_TmpSignalConversionAtSFunct[133] = 0U;
  rtb_TmpSignalConversionAtSFunct[134] = 0U;
  rtb_TmpSignalConversionAtSFunct[135] = 0U;
  rtb_TmpSignalConversionAtSFunct[136] = 0U;
  rtb_TmpSignalConversionAtSFunct[137] = 0U;
  rtb_TmpSignalConversionAtSFunct[138] = 0U;
  rtb_TmpSignalConversionAtSFunct[139] = 0U;
  rtb_TmpSignalConversionAtSFunct[140] = 3U;
  rtb_TmpSignalConversionAtSFunct[141] = 0U;
  rtb_TmpSignalConversionAtSFunct[142] = 0U;
  rtb_TmpSignalConversionAtSFunct[143] = 0U;
  rtb_TmpSignalConversionAtSFunct[144] = 0U;
  rtb_TmpSignalConversionAtSFunct[145] = 0U;
  rtb_TmpSignalConversionAtSFunct[146] = 0U;
  rtb_TmpSignalConversionAtSFunct[147] = 0U;
  rtb_TmpSignalConversionAtSFunct[148] = 0U;
  rtb_TmpSignalConversionAtSFunct[149] = 0U;
  rtb_TmpSignalConversionAtSFunct[150] = 2U;
  rtb_TmpSignalConversionAtSFunct[151] = 2U;
  rtb_TmpSignalConversionAtSFunct[152] = 2U;
  rtb_TmpSignalConversionAtSFunct[153] = 1U;
  rtb_TmpSignalConversionAtSFunct[154] = 1U;

  /* SignalConversion generated from: '<S5>/ SFunction ' incorporates:
   *  Chart: '<S3>/FltCodeArry'
   *  Constant: '<S3>/Constant156'
   *  Constant: '<S3>/Constant161'
   *  Constant: '<S3>/Constant162'
   *  Constant: '<S3>/Constant163'
   *  Constant: '<S3>/Constant164'
   *  Constant: '<S3>/Constant165'
   *  Constant: '<S3>/Constant166'
   *  Constant: '<S3>/Constant167'
   *  Constant: '<S3>/Constant168'
   *  Constant: '<S3>/Constant169'
   *  Constant: '<S3>/Constant170'
   *  Constant: '<S3>/Constant171'
   *  Constant: '<S3>/Constant172'
   *  Constant: '<S3>/Constant173'
   *  Constant: '<S3>/Constant174'
   *  Constant: '<S3>/Constant175'
   *  Constant: '<S3>/Constant176'
   *  Constant: '<S3>/Constant177'
   *  Constant: '<S3>/Constant178'
   *  Constant: '<S3>/Constant179'
   *  Constant: '<S3>/Constant180'
   *  Constant: '<S3>/Constant181'
   *  Constant: '<S3>/Constant182'
   *  Constant: '<S3>/Constant183'
   *  Constant: '<S3>/Constant184'
   *  Constant: '<S3>/Constant185'
   *  Constant: '<S3>/Constant186'
   *  Constant: '<S3>/Constant187'
   *  Constant: '<S3>/Constant188'
   *  Constant: '<S3>/Constant189'
   *  Constant: '<S3>/Constant190'
   *  Constant: '<S3>/Constant191'
   *  Constant: '<S3>/Constant192'
   *  Constant: '<S3>/Constant193'
   *  Constant: '<S3>/Constant194'
   *  Constant: '<S3>/Constant195'
   *  Constant: '<S3>/Constant196'
   *  Constant: '<S3>/Constant197'
   *  Constant: '<S3>/Constant198'
   *  Constant: '<S3>/Constant199'
   *  Constant: '<S3>/Constant200'
   *  Constant: '<S3>/Constant201'
   *  Constant: '<S3>/Constant202'
   *  Constant: '<S3>/Constant203'
   *  Constant: '<S3>/Constant204'
   *  Constant: '<S3>/Constant205'
   *  Constant: '<S3>/Constant206'
   *  Constant: '<S3>/Constant207'
   *  Constant: '<S3>/Constant208'
   *  Constant: '<S3>/Constant209'
   *  Constant: '<S3>/Constant210'
   *  Constant: '<S3>/Constant211'
   *  Constant: '<S3>/Constant212'
   *  Constant: '<S3>/Constant213'
   *  Constant: '<S3>/Constant214'
   *  Constant: '<S3>/Constant215'
   *  Constant: '<S3>/Constant216'
   *  Constant: '<S3>/Constant217'
   *  Constant: '<S3>/Constant218'
   *  Constant: '<S3>/Constant219'
   *  Constant: '<S3>/Constant220'
   *  Constant: '<S3>/Constant221'
   *  Constant: '<S3>/Constant222'
   *  Constant: '<S3>/Constant223'
   *  Constant: '<S3>/Constant224'
   *  Constant: '<S3>/Constant225'
   *  Constant: '<S3>/Constant226'
   *  Constant: '<S3>/Constant227'
   *  Constant: '<S3>/Constant228'
   *  Constant: '<S3>/Constant229'
   *  Constant: '<S3>/Constant230'
   *  Constant: '<S3>/Constant231'
   *  Constant: '<S3>/Constant232'
   *  Constant: '<S3>/Constant233'
   *  Constant: '<S3>/Constant234'
   *  Constant: '<S3>/Constant235'
   *  Constant: '<S3>/Constant236'
   *  Constant: '<S3>/Constant237'
   *  Constant: '<S3>/Constant238'
   *  Constant: '<S3>/Constant239'
   *  Constant: '<S3>/Constant240'
   *  Constant: '<S3>/Constant241'
   *  Constant: '<S3>/Constant242'
   *  Constant: '<S3>/Constant243'
   *  Constant: '<S3>/Constant244'
   *  Constant: '<S3>/Constant245'
   *  Constant: '<S3>/Constant246'
   *  Constant: '<S3>/Constant247'
   *  Constant: '<S3>/Constant248'
   *  Constant: '<S3>/Constant249'
   *  Constant: '<S3>/Constant250'
   *  Constant: '<S3>/Constant251'
   *  Constant: '<S3>/Constant252'
   *  Constant: '<S3>/Constant253'
   *  Constant: '<S3>/Constant254'
   *  Constant: '<S3>/Constant255'
   *  Constant: '<S3>/Constant256'
   *  Constant: '<S3>/Constant257'
   *  Constant: '<S3>/Constant258'
   *  Constant: '<S3>/Constant259'
   *  Constant: '<S3>/Constant260'
   *  Constant: '<S3>/Constant261'
   *  Constant: '<S3>/Constant262'
   *  Constant: '<S3>/Constant263'
   *  Constant: '<S3>/Constant264'
   *  Constant: '<S3>/Constant265'
   *  Constant: '<S3>/Constant266'
   *  Constant: '<S3>/Constant267'
   *  Constant: '<S3>/Constant268'
   *  Constant: '<S3>/Constant269'
   *  Constant: '<S3>/Constant270'
   *  Constant: '<S3>/Constant271'
   *  Constant: '<S3>/Constant272'
   *  Constant: '<S3>/Constant273'
   *  Constant: '<S3>/Constant274'
   *  Constant: '<S3>/Constant275'
   *  Constant: '<S3>/Constant276'
   *  Constant: '<S3>/Constant277'
   *  Constant: '<S3>/Constant278'
   *  Constant: '<S3>/Constant279'
   *  Constant: '<S3>/Constant280'
   *  Constant: '<S3>/Constant281'
   *  Constant: '<S3>/Constant282'
   *  Constant: '<S3>/Constant283'
   *  Constant: '<S3>/Constant284'
   *  Constant: '<S3>/Constant285'
   *  Constant: '<S3>/Constant286'
   *  Constant: '<S3>/Constant287'
   *  Constant: '<S3>/Constant288'
   *  Constant: '<S3>/Constant289'
   *  Constant: '<S3>/Constant290'
   *  Constant: '<S3>/Constant291'
   *  Constant: '<S3>/Constant292'
   *  Constant: '<S3>/Constant293'
   *  Constant: '<S3>/Constant294'
   *  Constant: '<S3>/Constant295'
   *  Constant: '<S3>/Constant296'
   *  Constant: '<S3>/Constant297'
   *  Constant: '<S3>/Constant298'
   *  Constant: '<S3>/Constant299'
   *  Constant: '<S3>/Constant300'
   *  Constant: '<S3>/Constant301'
   *  Constant: '<S3>/Constant302'
   *  Constant: '<S3>/Constant303'
   *  Constant: '<S3>/Constant304'
   *  Constant: '<S3>/Constant305'
   *  Constant: '<S3>/Constant306'
   *  Constant: '<S3>/Constant307'
   *  Constant: '<S3>/Constant308'
   *  Constant: '<S3>/Constant309'
   *  Constant: '<S3>/Constant310'
   *  Constant: '<S3>/Constant311'
   *  Constant: '<S3>/Constant312'
   *  Constant: '<S3>/Constant313'
   *  Constant: '<S3>/Constant314'
   */
  rtb_TmpSignalConversionAtSFun_l[0] = 2U;
  rtb_TmpSignalConversionAtSFun_l[1] = 2U;
  rtb_TmpSignalConversionAtSFun_l[2] = 2U;
  rtb_TmpSignalConversionAtSFun_l[3] = 2U;
  rtb_TmpSignalConversionAtSFun_l[4] = 34U;
  rtb_TmpSignalConversionAtSFun_l[5] = 0U;
  rtb_TmpSignalConversionAtSFun_l[6] = 0U;
  rtb_TmpSignalConversionAtSFun_l[7] = 0U;
  rtb_TmpSignalConversionAtSFun_l[8] = 0U;
  rtb_TmpSignalConversionAtSFun_l[9] = 0U;
  rtb_TmpSignalConversionAtSFun_l[10] = 254U;
  rtb_TmpSignalConversionAtSFun_l[11] = 254U;
  rtb_TmpSignalConversionAtSFun_l[12] = 2U;
  rtb_TmpSignalConversionAtSFun_l[13] = 254U;
  rtb_TmpSignalConversionAtSFun_l[14] = 1U;
  rtb_TmpSignalConversionAtSFun_l[15] = 0U;
  rtb_TmpSignalConversionAtSFun_l[16] = 0U;
  rtb_TmpSignalConversionAtSFun_l[17] = 0U;
  rtb_TmpSignalConversionAtSFun_l[18] = 0U;
  rtb_TmpSignalConversionAtSFun_l[19] = 0U;
  rtb_TmpSignalConversionAtSFun_l[20] = 254U;
  rtb_TmpSignalConversionAtSFun_l[21] = 106U;
  rtb_TmpSignalConversionAtSFun_l[22] = 2U;
  rtb_TmpSignalConversionAtSFun_l[23] = 106U;
  rtb_TmpSignalConversionAtSFun_l[24] = 2U;
  rtb_TmpSignalConversionAtSFun_l[25] = 18U;
  rtb_TmpSignalConversionAtSFun_l[26] = 18U;
  rtb_TmpSignalConversionAtSFun_l[27] = 18U;
  rtb_TmpSignalConversionAtSFun_l[28] = 18U;
  rtb_TmpSignalConversionAtSFun_l[29] = 250U;
  rtb_TmpSignalConversionAtSFun_l[30] = 2U;
  rtb_TmpSignalConversionAtSFun_l[31] = 106U;
  rtb_TmpSignalConversionAtSFun_l[32] = 0U;
  rtb_TmpSignalConversionAtSFun_l[33] = 0U;
  rtb_TmpSignalConversionAtSFun_l[34] = 0U;
  rtb_TmpSignalConversionAtSFun_l[35] = 0U;
  rtb_TmpSignalConversionAtSFun_l[36] = 0U;
  rtb_TmpSignalConversionAtSFun_l[37] = 0U;
  rtb_TmpSignalConversionAtSFun_l[38] = 0U;
  rtb_TmpSignalConversionAtSFun_l[39] = 0U;
  rtb_TmpSignalConversionAtSFun_l[40] = 0U;
  rtb_TmpSignalConversionAtSFun_l[41] = 0U;
  rtb_TmpSignalConversionAtSFun_l[42] = 0U;
  rtb_TmpSignalConversionAtSFun_l[43] = 0U;
  rtb_TmpSignalConversionAtSFun_l[44] = 0U;
  rtb_TmpSignalConversionAtSFun_l[45] = 0U;
  rtb_TmpSignalConversionAtSFun_l[46] = 0U;
  rtb_TmpSignalConversionAtSFun_l[47] = 0U;
  rtb_TmpSignalConversionAtSFun_l[48] = 0U;
  rtb_TmpSignalConversionAtSFun_l[49] = 0U;
  rtb_TmpSignalConversionAtSFun_l[50] = 2U;
  rtb_TmpSignalConversionAtSFun_l[51] = 234U;
  rtb_TmpSignalConversionAtSFun_l[52] = 122U;
  rtb_TmpSignalConversionAtSFun_l[53] = 66U;
  rtb_TmpSignalConversionAtSFun_l[54] = 34U;
  rtb_TmpSignalConversionAtSFun_l[55] = 66U;
  rtb_TmpSignalConversionAtSFun_l[56] = 34U;
  rtb_TmpSignalConversionAtSFun_l[57] = 2U;
  rtb_TmpSignalConversionAtSFun_l[58] = 2U;
  rtb_TmpSignalConversionAtSFun_l[59] = 18U;
  rtb_TmpSignalConversionAtSFun_l[60] = 0U;
  rtb_TmpSignalConversionAtSFun_l[61] = 0U;
  rtb_TmpSignalConversionAtSFun_l[62] = 0U;
  rtb_TmpSignalConversionAtSFun_l[63] = 0U;
  rtb_TmpSignalConversionAtSFun_l[64] = 0U;
  rtb_TmpSignalConversionAtSFun_l[65] = 0U;
  rtb_TmpSignalConversionAtSFun_l[66] = 0U;
  rtb_TmpSignalConversionAtSFun_l[67] = 0U;
  rtb_TmpSignalConversionAtSFun_l[68] = 0U;
  rtb_TmpSignalConversionAtSFun_l[69] = 0U;
  rtb_TmpSignalConversionAtSFun_l[70] = 122U;
  rtb_TmpSignalConversionAtSFun_l[71] = 2U;
  rtb_TmpSignalConversionAtSFun_l[72] = 0U;
  rtb_TmpSignalConversionAtSFun_l[73] = 0U;
  rtb_TmpSignalConversionAtSFun_l[74] = 0U;
  rtb_TmpSignalConversionAtSFun_l[75] = 0U;
  rtb_TmpSignalConversionAtSFun_l[76] = 0U;
  rtb_TmpSignalConversionAtSFun_l[77] = 0U;
  rtb_TmpSignalConversionAtSFun_l[78] = 0U;
  rtb_TmpSignalConversionAtSFun_l[79] = 0U;
  rtb_TmpSignalConversionAtSFun_l[80] = 66U;
  rtb_TmpSignalConversionAtSFun_l[81] = 66U;
  rtb_TmpSignalConversionAtSFun_l[82] = 234U;
  rtb_TmpSignalConversionAtSFun_l[83] = 131U;
  rtb_TmpSignalConversionAtSFun_l[84] = 3U;
  rtb_TmpSignalConversionAtSFun_l[85] = 2U;
  rtb_TmpSignalConversionAtSFun_l[86] = 66U;
  rtb_TmpSignalConversionAtSFun_l[87] = 66U;
  rtb_TmpSignalConversionAtSFun_l[88] = 162U;
  rtb_TmpSignalConversionAtSFun_l[89] = 131U;
  rtb_TmpSignalConversionAtSFun_l[90] = 0U;
  rtb_TmpSignalConversionAtSFun_l[91] = 0U;
  rtb_TmpSignalConversionAtSFun_l[92] = 0U;
  rtb_TmpSignalConversionAtSFun_l[93] = 0U;
  rtb_TmpSignalConversionAtSFun_l[94] = 0U;
  rtb_TmpSignalConversionAtSFun_l[95] = 0U;
  rtb_TmpSignalConversionAtSFun_l[96] = 0U;
  rtb_TmpSignalConversionAtSFun_l[97] = 0U;
  rtb_TmpSignalConversionAtSFun_l[98] = 0U;
  rtb_TmpSignalConversionAtSFun_l[99] = 0U;
  rtb_TmpSignalConversionAtSFun_l[100] = 250U;
  rtb_TmpSignalConversionAtSFun_l[101] = 145U;
  rtb_TmpSignalConversionAtSFun_l[102] = 234U;
  rtb_TmpSignalConversionAtSFun_l[103] = 3U;
  rtb_TmpSignalConversionAtSFun_l[104] = 3U;
  rtb_TmpSignalConversionAtSFun_l[105] = 0U;
  rtb_TmpSignalConversionAtSFun_l[106] = 250U;
  rtb_TmpSignalConversionAtSFun_l[107] = 19U;
  rtb_TmpSignalConversionAtSFun_l[108] = 250U;
  rtb_TmpSignalConversionAtSFun_l[109] = 19U;
  rtb_TmpSignalConversionAtSFun_l[110] = 106U;
  rtb_TmpSignalConversionAtSFun_l[111] = 3U;
  rtb_TmpSignalConversionAtSFun_l[112] = 106U;
  rtb_TmpSignalConversionAtSFun_l[113] = 3U;
  rtb_TmpSignalConversionAtSFun_l[114] = 250U;
  rtb_TmpSignalConversionAtSFun_l[115] = 146U;
  rtb_TmpSignalConversionAtSFun_l[116] = 0U;
  rtb_TmpSignalConversionAtSFun_l[117] = 0U;
  rtb_TmpSignalConversionAtSFun_l[118] = 0U;
  rtb_TmpSignalConversionAtSFun_l[119] = 0U;
  rtb_TmpSignalConversionAtSFun_l[120] = 0U;
  rtb_TmpSignalConversionAtSFun_l[121] = 0U;
  rtb_TmpSignalConversionAtSFun_l[122] = 0U;
  rtb_TmpSignalConversionAtSFun_l[123] = 0U;
  rtb_TmpSignalConversionAtSFun_l[124] = 0U;
  rtb_TmpSignalConversionAtSFun_l[125] = 0U;
  rtb_TmpSignalConversionAtSFun_l[126] = 0U;
  rtb_TmpSignalConversionAtSFun_l[127] = 0U;
  rtb_TmpSignalConversionAtSFun_l[128] = 0U;
  rtb_TmpSignalConversionAtSFun_l[129] = 0U;
  rtb_TmpSignalConversionAtSFun_l[130] = 66U;
  rtb_TmpSignalConversionAtSFun_l[131] = 34U;
  rtb_TmpSignalConversionAtSFun_l[132] = 18U;
  rtb_TmpSignalConversionAtSFun_l[133] = 0U;
  rtb_TmpSignalConversionAtSFun_l[134] = 0U;
  rtb_TmpSignalConversionAtSFun_l[135] = 0U;
  rtb_TmpSignalConversionAtSFun_l[136] = 0U;
  rtb_TmpSignalConversionAtSFun_l[137] = 0U;
  rtb_TmpSignalConversionAtSFun_l[138] = 0U;
  rtb_TmpSignalConversionAtSFun_l[139] = 0U;
  rtb_TmpSignalConversionAtSFun_l[140] = 131U;
  rtb_TmpSignalConversionAtSFun_l[141] = 0U;
  rtb_TmpSignalConversionAtSFun_l[142] = 0U;
  rtb_TmpSignalConversionAtSFun_l[143] = 0U;
  rtb_TmpSignalConversionAtSFun_l[144] = 0U;
  rtb_TmpSignalConversionAtSFun_l[145] = 0U;
  rtb_TmpSignalConversionAtSFun_l[146] = 0U;
  rtb_TmpSignalConversionAtSFun_l[147] = 0U;
  rtb_TmpSignalConversionAtSFun_l[148] = 0U;
  rtb_TmpSignalConversionAtSFun_l[149] = 0U;
  rtb_TmpSignalConversionAtSFun_l[150] = 2U;
  rtb_TmpSignalConversionAtSFun_l[151] = 2U;
  rtb_TmpSignalConversionAtSFun_l[152] = 2U;
  rtb_TmpSignalConversionAtSFun_l[153] = 0U;
  rtb_TmpSignalConversionAtSFun_l[154] = 0U;

  /* Chart: '<S3>/FltCodeArry' incorporates:
   *  Constant: '<S3>/Constant'
   *  Constant: '<S3>/Constant266'
   *  Constant: '<S3>/Constant315'
   *  Constant: '<S3>/Constant317'
   *  Constant: '<S3>/Constant53'
   *  SignalConversion generated from: '<S5>/ SFunction '
   */
  avrgU = 0U;
  sfmd_num_fltNum = 0U;
  for (i_0 = 0; i_0 < 20; i_0++) {
    FltCodeArr[i_0] = 0U;
    rtb_FltLevelArr[i_0] = 0U;
    rtb_FltActArr[i_0] = 0U;
    FltCodeArrS[i_0] = 0U;
  }

  while (avrgU < 155) {
    if (rtb_TmpSignalConversionAtSFun_a[avrgU] && (sfmd_num_fltNum <
         sfmc_num_fltNumMax)) {
      FltCodeArr[sfmd_num_fltNum] = (uint16_T)(avrgU + 1);
      rtb_FltLevelArr[sfmd_num_fltNum] = rtb_TmpSignalConversionAtSFunct[avrgU];
      rtb_FltActArr[sfmd_num_fltNum] = rtb_TmpSignalConversionAtSFun_l[avrgU];
      sfmd_num_fltNum = (uint16_T)(sfmd_num_fltNum + 1);
      if (avrgU == 51) {
        for (k = 0U; k < cmnc_num_cellUNum; k++) {
          if (SFM_B.ErrFlg[k]) {
            FltCodeArr[sfmd_num_fltNum] = (uint16_T)(k + 2001);
            rtb_FltLevelArr[sfmd_num_fltNum] = 4U;
            rtb_FltActArr[sfmd_num_fltNum] = 234U;
            i_0 = sfmd_num_fltNum + 1;
            if (sfmd_num_fltNum + 1 > 65535) {
              i_0 = 65535;
            }

            sfmd_num_fltNum = (uint16_T)i_0;
          }
        }
      }
    }

    avrgU++;
  }

  for (avrgU = 0U; avrgU < sfmd_num_fltNum; avrgU++) {
    i_0 = rtb_FltLevelArr[avrgU] * 10000 + FltCodeArr[avrgU];
    if (i_0 > 65535) {
      i_0 = 65535;
    }

    FltCodeArrS[avrgU] = (uint16_T)i_0;
  }

  for (avrgU = 0U; avrgU < sfmd_num_fltNum; avrgU++) {
    for (k = 0U; k < (sfmd_num_fltNum - avrgU) - 1; k++) {
      tmp_3 = FltCodeArrS[k + 1];
      if (FltCodeArrS[k] < tmp_3) {
        temp = FltCodeArrS[k];
        FltCodeArrS[k] = tmp_3;
        FltCodeArrS[k + 1] = temp;
      }
    }
  }

  if ((SFM_DW.Cntl > 4) || (SFM_DW.Cntl >= sfmd_num_fltNum)) {
    SFM_DW.Cntl = 0U;
  }

  avrgU = FltCodeArrS[SFM_DW.Cntl];
  i_0 = SFM_DW.Cntl + 1;
  if (SFM_DW.Cntl + 1 > 65535) {
    i_0 = 65535;
  }

  SFM_DW.Cntl = (uint16_T)i_0;

  /* S-Function (sfix_bitop): '<S3>/Bitwise Operator1' */
  sfmd_st_fltAct = rtb_FltActArr[0];

  /* MinMax: '<S3>/MinMax' */
  sfmd_N_fltLevel = rtb_FltLevelArr[0];
  for (i_0 = 0; i_0 < 19; i_0++) {
    /* S-Function (sfix_bitop): '<S3>/Bitwise Operator1' */
    sfmd_st_fltAct = (uint8_T)(rtb_FltActArr[i_0 + 1] | sfmd_st_fltAct);

    /* MinMax: '<S3>/MinMax' */
    i = rtb_FltLevelArr[i_0 + 1];
    if (sfmd_N_fltLevel <= i) {
      sfmd_N_fltLevel = i;
    }
  }

  /* Math: '<S3>/Rem1' */
  sfmd_idx_fltCode = (uint16_T)(avrgU % 10000);

  /* Chart: '<S13>/Chart' incorporates:
   *  Constant: '<S13>/Constant'
   */
  qY_0 = cmnc_num_cellUNum == 0U ? MAX_uint32_T : rtb_SumU / cmnc_num_cellUNum;
  if (qY_0 > 65535U) {
    qY_0 = 65535U;
  }

  /* SignalConversion generated from: '<S13>/Chart' incorporates:
   *  Chart: '<S13>/Chart'
   */
  sfmd_V_cellUAvrg = (uint16_T)qY_0;

  /* Product: '<S23>/Product' incorporates:
   *  Inport: '<Root>/ihd_L_urtRecv'
   *  RelationalOperator: '<S9>/Relational Operator'
   *  UnitDelay: '<S23>/Time_Delay'
   */
  SFM_DW.Time_Delay_DSTATE = (uint16_T)(ihd_L_urtRecv == 0 ? (int32_T)
    rtb_Saturation : 0);
  for (i_0 = 0; i_0 < 6; i_0++) {
    /* SignalConversion: '<S15>/Signal Conversion' incorporates:
     *  Inport: '<Root>/ihv_T_modT'
     */
    sfmv_T_modT[i_0] = ihv_T_modT[i_0];
  }
}

/* Model initialize function */
void SFM_initialize(const char_T **rt_errorStatus)
{
  RT_MODEL_SFM_T *const SFM_M = &(SFM_MdlrefDW.rtm);

  /* Registration code */

  /* initialize error status */
  rtmSetErrorStatusPointer(SFM_M, rt_errorStatus);
}

/*
 * File trailer for generated code.
 *
 * [EOF]
 */
